/*
 * Copyright 2019 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PERIPHERALS_H_
#define _PERIPHERALS_H_

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "fsl_edma.h"
#include "fsl_dmamux.h"
#include "fsl_common.h"
#include "fsl_lptmr.h"
#include "fsl_adc16.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/
/* Definitions for BOARD_InitPeripherals functional group */
/* Used DMA device. */
#define DEMO_EDMA_DMA_BASEADDR DMA0
/* Associated DMAMUX device that is used for muxing of requests. */
#define DEMO_EDMA_DMAMUX_BASEADDR DMAMUX

/* Channel ADC0 definitions */
/* eDMA eDMA source request. */
#define DEMO_EDMA_ADC0_DMA_REQUEST kDmaRequestMux0ADC0
/* Selected eDMA channel number. */
#define DEMO_EDMA_ADC0_DMA_CHANNEL 0
/* eDMA interrupt vector ID (number). */
#define DEMO_EDMA_DMA_CH_INT_DONE_0_IRQN DMA0_IRQn
/* eDMA interrupt handler identifier. */
#define DEMO_EDMA_DMA_CH_INT_DONE_0_IRQHANDLER DMA0_IRQHandler
/* BOARD_InitPeripherals defines for LPTMR0 */
/* Definition of peripheral ID */
#define DEMO_LPTMR_PERIPHERAL LPTMR0
/* Definition of the clock source frequency */
#define DEMO_LPTMR_CLK_FREQ 1000UL
/* Definition of the prescaled clock source frequency */
#define DEMO_LPTMR_INPUT_FREQ 1000UL
/* Definition of the timer period in us */
#define DEMO_LPTMR_USEC_COUNT 100000UL
/* Definition of the timer period in number of ticks */
#define DEMO_LPTMR_TICKS 100UL
/* Alias for ADC0 peripheral */
#define DEMO_ADC16_PERIPHERAL ADC0
/* ADC16 interrupt vector ID (number). */
#define DEMO_ADC16_IRQN ADC0_IRQn
/* ADC16 interrupt handler identifier. */
#define DEMO_ADC16_IRQHANDLER ADC0_IRQHandler

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/
extern const edma_config_t DEMO_eDMA_config;
extern edma_handle_t DEMO_eDMA_ADC0_Handle;
extern const lptmr_config_t DEMO_LPTMR_config;
extern adc16_channel_config_t DEMO_ADC16_channelsConfig[1];
extern const adc16_config_t DEMO_ADC16_config;
extern const adc16_channel_mux_mode_t DEMO_ADC16_muxMode;
extern const adc16_hardware_average_mode_t DEMO_ADC16_hardwareAverageMode;

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void);

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void);

#if defined(__cplusplus)
}
#endif

#endif /* _PERIPHERALS_H_ */
